/* ////////////////////////////////////////////////////////////////////
//                                                                   //
//  FegInc.H                                         FalconMQ Client //
//                                                                   //
//  PURPOSE:                                                         //
//      The header file for the FegStub.                             //
//                                                                   //
//  Changes:                                                         //
//                                                                   //
//                                      Level 8 Systems - Copyrights //
//////////////////////////////////////////////////////////////////// */
#ifndef _FEGINC_H
#define _FEGINC_H

#ifdef __cplusplus
extern "C"
{
#endif

/* define for Special Access All for PSECURITY_DESCRIPTOR in 
   MQCreateQueue */
#define PSD_SPECIALACCESS_ALL ((PSECURITY_DESCRIPTOR)0xFFFFFFFF)
/*
   allows the IP Address and Port Number to be specified via an API 
   as opposed to using the env variable settings.  This call must be 
   issued per thread prior to issuing of the first MQ API Call or 
   after a call to the FMQDisconnect.
*/
HANDLE APIENTRY FMQConnect (char* pszServerName, int iPort,
                                 char *pszDomain, char *pszUserName,
                                 char *pszPassword, void *pPublicKey);
void APIENTRY FMQDisconnect (HANDLE);

/* prototypes for user defined Error handlers */

/*  */
typedef void (*GWErrFNText)  (    
  const char* pErrorString,     /* textual description of the error */
  const char* pOSErrorString,   /* textual description of OS        */
                                /* specific error                   */
  const char* pFuncName,        /* function the error occured in    */
  unsigned long dwLineNum,      /* line number error was on         */
  const char* pFileName,        /* source file the error was in     */
  const char* pModuleBuildDate, /* date that fegstub was built      */
  const char* pModuleBuildTime, /* time that fesgstub was built     */
  const char* pSourceTimeStamp  /* date & time sourcefile was built */
                              );

typedef void (*GWErrFNContext) (  
  const char* pFuncName,        /* function the error occured in    */
  unsigned long dwLineNum,      /* line number error was on         */
  const char* pFileName,        /* source file the error was in     */
  const char* pModuleBuildDate, /* date that fegstub was built      */
  const char* pModuleBuildTime, /* time that fesgstub was built     */
  const char* pSourceTimeStamp  /* date & time sourcefile was built */
                                );

extern GWErrFNText pGWErrFNText;
extern GWErrFNContext pGWErrFNContext;

HRESULT APIENTRY Commit(ITransaction **ppTransaction, 
						BOOL fRetaining, DWORD grfTC, DWORD grfRM);

HRESULT APIENTRY Abort(ITransaction **ppTransaction, 
					   BOID *pboidReason, 
					   BOOL fRetaining, BOOL fAsync);

			/* size is 2 */
typedef 
enum XACTTC
    {	XACTTC_SYNC_PHASEONE	= 1,
	XACTTC_SYNC_PHASETWO	= 2,
	XACTTC_SYNC	= 2,
	XACTTC_ASYNC_PHASEONE	= 4,
	XACTTC_ASYNC	= 4
    }	XACTTC;

#ifdef __cplusplus
}
#endif

#endif
